Name "RapidWriter"
OutFile "rapidwriter-setup.exe"

SetCompressor lzma

InstallDir "$PROGRAMFILES\RapidWriter"
InstallDirRegKey HKEY_LOCAL_MACHINE "SOFTWARE\RapidWriter" ""

DirText "Select the directory to install RapidWriter in:"

Icon "ui\resources\app_icon.ico"


Function .onInit
  System::Call 'kernel32::CreateMutexA(i 0, i 0, t "RapidWriterSetup") ?e'
  Pop $R0
  StrCmp $R0 0 +3
    MessageBox MB_OK "The installer is already running."
    Abort
FunctionEnd


Section ""
    ; Install files.
    SetOverwrite on

    SetOutPath "$INSTDIR"
    File "build\bdist.py2exe\rapidwriter.exe"
    File "build\bdist.py2exe\*.dll"
    File "build\bdist.py2exe\*.pyd"
    File "build\bdist.py2exe\syslinux.exe"
    File "build\bdist.py2exe\mbr.bin"
    File "build\bdist.py2exe\COPYING"
    File "misc\vcredist_x86.exe"

    SetOutPath "$INSTDIR\imageformats"
    File "build\bdist.py2exe\imageformats\*.dll"
    
    ; Create shortcut.
    SetOutPath -
    CreateDirectory "$SMPROGRAMS\RapidWriter"
    CreateShortCut "$SMPROGRAMS\RapidWriter\RapidWriter.lnk" "$INSTDIR\rapidwriter.exe"
    CreateShortCut "$SMPROGRAMS\RapidWriter\Uninstall RapidWriter.lnk" "$INSTDIR\uninst.exe" "" "$INSTDIR\uninst.exe" 0

    ; Install MS VC++ runtime via the redistributable installer.
    ; /qb! causes a progress bar to be displayed.  Use /qn instead to get a completely
    ; silent install.
    ExecWait '"$INSTDIR\vcredist_x86.exe" /q:a /c:"VCREDI~1.EXE /q:a /c:""msiexec /i vcredist.msi /qb!"" "'

    ; Optionally start program.
    MessageBox MB_YESNO|MB_ICONQUESTION "Run RapidWriter now?" IDNO SkipRunProgram
    Exec "$INSTDIR\rapidwriter.exe"
SkipRunProgram:

    ; Create uninstaller.
    WriteRegStr HKEY_LOCAL_MACHINE "SOFTWARE\RapidWriter" "" "$INSTDIR"
    WriteRegStr HKEY_LOCAL_MACHINE "Software\Microsoft\Windows\CurrentVersion\Uninstall\RapidWriter" "DisplayName" "RapidWriter (remove only)"
    WriteRegStr HKEY_LOCAL_MACHINE "Software\Microsoft\Windows\CurrentVersion\Uninstall\RapidWriter" "UninstallString" '"$INSTDIR\uninst.exe"'
    WriteUninstaller "$INSTDIR\uninst.exe"
SectionEnd


UninstallText "This will uninstall RapidWriter from your system."

Section Uninstall
    ; Delete shortcuts.
    Delete "$SMPROGRAMS\RapidWriter\RapidWriter.lnk"
    Delete "$SMPROGRAMS\RapidWriter\Uninstall RapidWriter.lnk"
    RMDir "$SMPROGRAMS\RapidWriter"
    Delete "$DESKTOP\RapidWriter.lnk"

    ; Delete registry keys.
    Delete "$INSTDIR\uninst.exe"
    DeleteRegKey HKEY_LOCAL_MACHINE "SOFTWARE\RapidWriter"
    DeleteRegKey HKEY_LOCAL_MACHINE "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\RapidWriter"

    ; Delete files.
    Delete "$INSTDIR\rapidwriter.exe"
    Delete "$INSTDIR\*.pyd"
    Delete "$INSTDIR\*.dll"
    Delete "$INSTDIR\syslinux.exe"
    Delete "$INSTDIR\mbr.bin"
    Delete "$INSTDIR\COPYING"
    Delete "$INSTDIR\vcredist_x86.exe"
    Delete "$INSTDIR\imageformats\*.dll"
    Delete "$INSTDIR\rapidwriter.exe.log"

    ; Remove the installation directories.
    RMDir "$INSTDIR\imageformats"
    RMDir "$INSTDIR"
SectionEnd
